// Generated by dts-bundle-generator v9.3.1

import { Page } from 'playwright-core';

// Generated by dts-bundle-generator v9.3.1
export type IgnoreElements = Array<string>;
declare enum Level {
	A = "A",
	AA = "AA",
	AAA = "AAA",
	BESTPRACTICE = "BESTPRACTICE",
	EXPERIMENTAL = "EXPERIMENTAL"
}
declare enum Severity {
	MINOR = "MINOR",
	MODERATE = "MODERATE",
	SERIOUS = "SERIOUS",
	CRITICAL = "CRITICAL"
}
declare enum CSR {
	YES = "YES",
	PARTIAL = "PARTIAL",
	"N/A" = "N/A",
	NODATA = "NODATA"
}
declare enum WidgetCoverage {
	YES = "YES",
	PARTIAL = "PARTIAL",
	NODATA = "NODATA",
	"N/A" = "NA"
}
declare enum DisabilitiesAffected {
	BLIND = "BLIND",
	COGNITIVE = "COGNITIVE",
	COLOR_BLINDNESS = "COLOR_BLINDNESS",
	DEAF = "DEAF",
	DEAF_BLINDNESS = "DEAF_BLINDNESS",
	LOW_VISION = "LOW_VISION",
	MOBILITY = "MOBILITY",
	ATTENTION_DEFICIT = "ATTENTION_DEFICIT",
	AUTISM = "AUTISM",
	DEAF_BLIND = "DEAF_BLIND",
	DYSLEXIA = "DYSLEXIA",
	KEYBOARD_USERS = "KEYBOARD_USERS",
	KEYBOARD = "KEYBOARD",
	NODATA = "NODATA"
}
declare enum Areas {
	SCREEN_READER = "SCREEN_READER",
	KEYBOARD_NAV = "KEYBOARD_NAV",
	SWITCH = "SWITCH",
	VISUAL = "VISUAL",
	VOICE_CONTROL = "VOICE_CONTROL",
	KEYBOARD = "KEYBOARD",
	NODATA = "NODATA"
}
export type RuleDescriptor = {
	description: string;
	display: string;
	errorMessage: string;
	id: number;
	level: Level;
	key: string;
	references: Array<{
		label: string;
		url: string;
	}>;
	recommendation: string;
	severity: Severity;
	csr?: CSR;
	widgetCoverage?: WidgetCoverage;
	disabilitiesAffected: Array<keyof typeof DisabilitiesAffected>;
	areas: Array<keyof typeof Areas>;
	successCriteria: Array<{
		label: string;
		url: string;
	}>;
};
export interface ElementDimensions {
	top: number;
	left: number;
	bottom: number;
	right: number;
	width: number;
	height: number;
}
declare enum IssueType {
	violation = "violation",
	inapplicable = "inapplicable",
	incomplete = "incomplete"
}
export type TargetElement = Element | Document;
export interface Issue<T extends TargetElement = Element> {
	attributesCount: number;
	cssSelector: string;
	dimensions?: ElementDimensions | undefined;
	element: T;
	elementId: string;
	encodedContent?: number[] | undefined;
	isVisuallyHidden?: boolean;
	fingerprint: string;
	groupKey?: string | undefined;
	pathSelector: string;
	ruleId: string;
	screenshotPath?: string;
	selector: string;
	snippet?: string;
	srcAttr: string;
	tag: string;
	type: IssueType;
	variant?: string | undefined;
	xpath: string;
	meta: IssueMeta;
}
export interface IssueMeta {
	tag?: string;
	attributes: Record<string, string | null>;
	state: Record<string, boolean>;
}
export type Base = {
	actIds?: string[];
	description?: string;
	id: string;
	level?: RuleLevel;
	outputType?: OutputType;
	severity?: SeverityRange;
	uwId?: number;
};
declare enum RuleLevel {
	A = "A",
	AA = "AA",
	AAA = "AAA",
	BestPractice = "Best Practice",
	Experimental = "Experimental"
}
export type SeverityRange = 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10;
export type OutputType = undefined | "group" | "tbd";
export type RuleSpecificOptions = {
	emptyAltAsPresentationalRole?: boolean;
};
export interface RuleAnalyzeResult<T extends TargetElement> {
	count: AnalyzeCount;
	issues: Issue<T>[];
	issuesGroup: Record<string, Issue<T>[]>;
}
export type AnalyzeCountType = "reviewed" | "passed" | keyof typeof IssueType;
export type AnalyzeCount = Record<AnalyzeCountType, number>;
export type Rule<T extends TargetElement = TargetElement> = {
	actIds?: Base["actIds"];
	analyze: (ruleSpecificOptions?: RuleSpecificOptions, root?: Document | Element) => RuleAnalyzeResult<T>;
	description: RuleDescriptor["description"];
	display: RuleDescriptor["display"];
	errorMessage: RuleDescriptor["errorMessage"];
	id: Base["id"];
	level: RuleDescriptor["level"];
	outputType?: Base["outputType"];
	recommendation: RuleDescriptor["recommendation"];
	references: RuleDescriptor["references"];
	severity: RuleDescriptor["severity"];
	areas: RuleDescriptor["areas"];
	disabilitiesAffected: RuleDescriptor["disabilitiesAffected"];
	successCriteria: RuleDescriptor["successCriteria"];
	uwId: Base["uwId"];
};
declare enum Outcome {
	passed = "passed",
	failed = "failed",
	inapplicable = "inapplicable",
	cantTell = "cantTell"
}
export interface AlchemyFix {
	fixType?: number;
	domSpec?: boolean;
	helperText?: string;
	fix: Record<string, string | boolean | null>;
}
export interface Fingerprint {
	attNo: number;
	css: string;
	encoding: number[];
	version: number;
}
export interface AccessEngineReportRecord {
	attribute: string;
	attributeDetail: string;
	bestPracticeId: number;
	element: string;
	engineTestId: number;
	fingerprint: Fingerprint | null;
	fixType: AlchemyFix | null;
	path: string;
	testResult: number;
}
export interface AnalysisConfig {
	includeRules?: string[];
	excludeRules?: string[];
	includeBestPractices?: boolean;
	includeExperimental?: boolean;
	level?: "A" | "AA" | "AAA" | null;
	ignoreSelectors?: IgnoreElements;
	switchOff?: boolean;
	ruleSpecificOptions?: RuleSpecificOptions;
	rootSelector?: string;
	onRuleError?: (error: AnalyzeError) => void;
}
export type AnalyzeResultRecord = RuleAnalyzeResult<any> & {
	areas: Rule["areas"];
	description: Rule["description"];
	disabilitiesAffected: Rule["disabilitiesAffected"];
	display: Rule["display"];
	errorMessage: Rule["errorMessage"];
	level: Rule["level"];
	outcome: Outcome;
	outputType: OutputType;
	recommendation: Rule["recommendation"];
	ruleId: Rule["id"];
	severity: Rule["severity"];
	successCriteria: Rule["successCriteria"];
	accessEngineReport?: AccessEngineReportRecord[];
};
export type AnalyzeError = {
	ruleId: string;
	errorMessage: string;
};
export type AnalyzeResult = {
	result: Record<string, AnalyzeResultRecord>;
	config?: AnalysisConfig;
};
export declare enum RulesIds {
	AccessibleName = "accessible-name",
	Accesskeys = "accesskeys",
	AreaAlt = "area-alt",
	AriaAllowedAttr = "aria-allowed-attr",
	AriaAllowedRole = "aria-allowed-role",
	AriaCommandName = "aria-command-name",
	AriaDialogName = "aria-dialog-name",
	AriaHiddenBody = "aria-hidden-body",
	AriaHiddenFocus = "aria-hidden-focus",
	AriaInputFieldName = "aria-input-field-name",
	AriaMeterName = "aria-meter-name",
	AriaProgressbarName = "aria-progressbar-name",
	AriaRequiredAttr = "aria-required-attr",
	AriaRequiredChildren = "aria-required-children",
	AriaRequiredParent = "aria-required-parent",
	AriaRoledescription = "aria-roledescription",
	AriaRoles = "aria-roles",
	AriaText = "aria-text",
	AriaToggleFieldName = "aria-toggle-field-name",
	AriaTooltipName = "aria-tooltip-name",
	AriaTreeitemName = "aria-treeitem-name",
	AriaValidAttr = "aria-valid-attr",
	AriaValidAttrValue = "aria-valid-attr-value",
	AutocompleteValid = "autocomplete-valid",
	AvoidInlineSpacing = "avoid-inline-spacing",
	Blink = "blink",
	Bold = "bold",
	ButtonName = "button-name",
	Bypass = "bypass",
	BypassHeading = "bypass-heading",
	BypassLandmark = "bypass-landmark",
	BypassMoveFocus = "bypass-move-focus",
	ColorContrast = "color-contrast",
	ColorContrastEnhanced = "color-contrast-enhanced",
	CssOrientationLock = "css-orientation-lock",
	CustomFocusableElements = "custom-focusable-elements",
	DefinitionList = "definition-list",
	Dlitem = "dlitem",
	DocumentTitle = "document-title",
	DuplicateId = "duplicate-id",
	DuplicateIdActive = "duplicate-id-active",
	DuplicateIdAria = "duplicate-id-aria",
	EmptyHeading = "empty-heading",
	EmptyTableHeader = "empty-table-header",
	EventsHandling = "events-handling",
	FieldsetLegend = "fieldset-legend",
	FocusOrderSemantics = "focus-order-semantics",
	FormFieldMultipleLabels = "form-field-multiple-labels",
	FrameFocusableContent = "frame-focusable-content",
	FrameTitle = "frame-title",
	FrameTitleUnique = "frame-title-unique",
	FrameValidAttrValue = "frame-valid-attr-value",
	HeadingOrder = "heading-order",
	HiddenContent = "hidden-content",
	HrValidAttr = "hr-valid-attr",
	HtmlHasLang = "html-has-lang",
	HtmlLangValid = "html-lang-valid",
	HtmlXmlLangMismatch = "html-xml-lang-mismatch",
	IdenticalLinksSamePurpose = "identical-links-same-purpose",
	ImageAlt = "image-alt",
	ImageAltLong = "image-alt-long",
	ImageAltSuspicious = "image-alt-suspicious",
	ImageLinkWithoutText = "image-link-without-text",
	ImageRedundantAlt = "image-redundant-alt",
	ImageSameAlt = "image-same-alt",
	InputButtonName = "input-button-name",
	InputImageAlt = "input-image-alt",
	InvalidId = "invalid-id",
	Italic = "italic",
	Label = "label",
	LabelContentNameMismatch = "label-content-name-mismatch",
	LabelTitleOnly = "label-title-only",
	LandmarkBannerIsTopLevel = "landmark-banner-is-top-level",
	LandmarkComplementaryIsTopLevel = "landmark-complementary-is-top-level",
	LandmarkContentinfoIsTopLevel = "landmark-contentinfo-is-top-level",
	LandmarkMainIsTopLevel = "landmark-main-is-top-level",
	LandmarkNoDuplicateBanner = "landmark-no-duplicate-banner",
	LandmarkNoDuplicateContentinfo = "landmark-no-duplicate-contentinfo",
	LandmarkNoDuplicateMain = "landmark-no-duplicate-main",
	LandmarkOneMain = "landmark-one-main",
	LandmarkUnique = "landmark-unique",
	LinkAmbiguousText = "link-ambiguous-text",
	LinkInTextBlock = "link-in-text-block",
	LinkName = "link-name",
	LinkNoMentionTargetBlank = "link-no-mention-target-blank",
	LinkReferToImage = "link-refer-to-image",
	List = "list",
	Listitem = "listitem",
	Marquee = "marquee",
	MetaRefresh = "meta-refresh",
	MetaRefreshNoExceptions = "meta-refresh-no-exceptions",
	MetaViewport = "meta-viewport",
	MetaViewportLarge = "meta-viewport-large",
	NestedInteractive = "nested-interactive",
	NoAutoplayAudio = "no-autoplay-audio",
	NoAutoplayAudioNoExceptions = "no-autoplay-audio-no-exceptions",
	ObjectAlt = "object-alt",
	PAsHeading = "p-as-heading",
	PageHasHeadingOne = "page-has-heading-one",
	PresentationRoleConflict = "presentation-role-conflict",
	Region = "region",
	RoleImgAlt = "role-img-alt",
	ScopeAttrValid = "scope-attr-valid",
	ScrollableRegionFocusable = "scrollable-region-focusable",
	SelectName = "select-name",
	ServerSideImageMap = "server-side-image-map",
	SkipLink = "skip-link",
	SuspiciousAccessibleName = "suspicious-accessible-name",
	SvgImgAlt = "svg-img-alt",
	Tabindex = "tabindex",
	TableContent = "table-content",
	TableDuplicateName = "table-duplicate-name",
	TableFakeCaption = "table-fake-caption",
	TargetSize = "target-size",
	TargetSizeLarge = "target-size-large",
	TdHasHeader = "td-has-header",
	TdHeadersAttr = "td-headers-attr",
	ThHasDataCells = "th-has-data-cells",
	TrContent = "tr-content",
	Track = "track",
	ValidAlt = "valid-alt",
	ValidLang = "valid-lang",
	VideoCaption = "video-caption"
}
export type AnalysisReportMeta = {
	date: string;
	htmlOrigin: string;
	relativePath: string;
	test: string[];
	url: string;
	version?: string;
	device?: "mobile" | "desktop";
	viewport?: {
		width: number;
		height: number;
	};
	pageScreenshot?: string;
	customTags?: string[];
	mode?: AnalysisMode;
	environment: {
		browser?: string;
		browserVersion?: string;
		userAgent?: string;
		framework: Framework;
		frameworkVersion?: string;
	};
};
export type Framework = "Cypress" | "Playwright" | "Puppeteer" | "UserWay" | "Selenium Python" | "Selenium Java" | "Selenium C#" | "WebdriverIO" | "Continuum Appium";
export type AnalysisMode = "background" | "manual";
export type ScreenshotsMetadata = Record<string, Record<string, string>>;
export interface LaunchConfig extends AnalysisConfig {
	reportIncomplete?: boolean;
	pageScreenshot?: boolean;
	strict?: boolean;
	printViolationsTable?: boolean;
	reportPath?: string;
	elementScreenshots?: boolean;
	detailedScreenshots?: boolean;
	ignoreUrls?: RegExp[];
	customTags?: string[];
}
export declare const setupUserway: (configOverride: LaunchConfig) => void;
export type AnalysysResultData = {
	screenshotsMeta?: ScreenshotsMetadata;
	violations: AnalyzeResultRecord[];
	fullReport: AnalyzeResult;
};
export declare function userwayAnalysisImpl(page: Page, config: Omit<LaunchConfig, "onRuleError">, mode: "manual" | "background", options?: {
	getRelativePath?: () => string;
	getTest?: () => string[];
	onStrict?: (violationsCount: number) => void;
}): Promise<AnalysysResultData>;
export declare class Controller {
	private page;
	private isStopped;
	private config;
	private options?;
	constructor(config?: Omit<LaunchConfig, "onRuleError">, options?: {
		getRelativePath?: () => string;
		getTest?: () => string[];
		onStrict?: (violationsCount: number) => void;
	});
	_setPage(page: Page): void;
	stop(): Promise<void>;
	start(): Promise<void>;
	_analyze(): Promise<void>;
}
export type UserwayController = Omit<Controller, "_analyze" | "_setPage">;
export declare const makeControllerFactory: (options?: {
	getRelativePath?: (() => string) | undefined;
	getTest?: (() => string[]) | undefined;
	onStrict?: ((violationsCount: number) => void) | undefined;
} | undefined) => (analysisConfig: LaunchConfig) => Promise<Controller>;
export type ReportFileFormats = "json" | "html" | "csv";
export interface SaveReportConfig {
	report: Array<AnalyzeResultRecord>;
	errors?: AnalyzeError[];
	config: LaunchConfig;
	meta: AnalysisReportMeta;
	format?: ReportFileFormats;
	reportPath: string;
	screenshotsMeta?: ScreenshotsMetadata;
	htmlContent: string;
}
export declare const saveReportArtifacts: (options: SaveReportConfig) => Promise<void>;
export declare const wrapPage: (page: Page, controller: Controller) => Page;
export type SetupUserwayFn = typeof setupUserway;
export type SaveReportArtifactsFn = typeof saveReportArtifacts;
export type SetupUserwayParams = Parameters<SetupUserwayFn>[0];
export type SaveReportParams = Parameters<SaveReportArtifactsFn>[0];

export {};
